<template>
  <div>
    <div
        v-if="tab === 'FOR_CLIENT'"
        class="filter-documentation__add-group"
        :class="[{'filter-documentation__bottom': direction === 'setting_direction'}]"
    >
      <div class="filter-documentation__add-group-left">
        <ob-select
            :remote-opt="loadListCustomers"
            v-model="selectedRole"
            placeholder="Выберите"
            label="Для клиента"
            class="filter-documentation__add-group-left-select"
            displayExp="name"
            valueExp="uuid"
            @input="selectedClient"
            ref="hasRole"
        />
        <ob-tooltip content="Выберите клиента">
          <control-group
              v-model="direction"
              :items="directions"
              theme="light"
              class="filter-documentation__tabs"
              @input="$emit('setDirection', direction)"
              :disabled="disableDirections"
          />
        </ob-tooltip>
      </div>
      <div
          v-if="hasPersonalSetting"
          @click="$parent.$refs['delete-all-settings'].open()"
          class="filter-documentation__add-group-right"
      >
        <i class="icon trash"/>
        Вернуться к общим настройкам
      </div>
    </div>

    <div v-if="direction !== 'setting_direction'" class="filter-documentation__text">
      <b>Сроки для документов</b>
    </div>

    <div v-if="direction !== 'setting_direction'" class="filter-documentation__inputs">
      <ObInput
          v-model="terms.provisionTerm[0].term"
          class="filter-documentation__inputs-input"
          label="Срок предоставления"
          placeholder="0"
          subTitle="дней"
          type="money:0"
          :isConvertMoney="false"
          @blur="changeTerms(terms)"
      />
      <ObInput
          v-model="terms.executionConfirmationTerm"
          class="filter-documentation__inputs-input"
          label="Срок проверки исполнения"
          placeholder="0"
          subTitle="дней"
          type="money:0"
          :isConvertMoney="false"
          @blur="changeTerms(terms)"
      />
      <ObInput
          v-model="terms.paymentTerm"
          class="filter-documentation__inputs-input"
          label="Срок оплаты"
          placeholder="0"
          subTitle="дней"
          type="money:0"
          :isConvertMoney="false"
          @blur="changeTerms(terms)"
      />
    </div>
  </div>
</template>

<script>
  import ObSelect from "common-components/src/obComponents/obSelect/index";
  import ObTooltip from "common-components/src/obComponents/obTooltip/index";
  import ObInput from "common-components/src/obComponents/obInput/index";
  import ControlGroup from "common-components/src/obComponents/obControlGroup";
  import {mapGetters, mapActions, mapMutations} from "vuex";
  import api from "@/api";

  export default {
    name: "AllClients",
    components: {
      ObSelect,
      ObTooltip,
      ObInput,
      ControlGroup
    },
    data() {
      return {
        selectedRole: '',
        directions: [
          {
            label: 'По всем направлениям',
            value: 'all_directions'
          },
          {
            label: 'Настроить направления',
            value: 'setting_direction'
          }
        ],
        direction: 'all_directions'
      }
    },
    computed: {
      ...mapGetters({
        tab: 'clicarSettings/tab',
        terms: 'clicarSettings/terms',
        personal_setting_customer: 'clicarSettings/personal_setting_customer',
        client_uuid: 'clicarSettings/client_uuid',
        clicar_uuid: 'clicarSettings/clicar_uuid',
        answerByServer: 'clicarSettings/answerByServer',
        flag_setting_direction: 'clicarSettings/flag_setting_direction',
        list_docs: 'clicarSettings/list_docs',
      }),
      disableDirections() {
        return this.selectedRole === ''
      },
      hasPersonalSetting() {
        const list = this.list_docs.some(key => (key.count > 0) || (key.required) || (key.comment !== ''));
        return !this.disableDirections && (Object.keys(this.personal_setting_customer).length || list);
      },
    },
    watch: {
      tab() {
        this.selectedRole = '';
        this.direction = 'all_directions';
        if (!this.flag_setting_direction) {
          this.CHANGE_SELECTED_CUSTOMER('');
        }
      },
      direction(direction) {
        this.$emit('changeDirection', direction)
      },
      selectedRole(role) {
        this.$emit('showRole', role)
      }
    },
    mounted() {
      if (this.flag_setting_direction) {
        this.SET_TABS('FOR_CLIENT');
        this.$nextTick(() => {
          this.selectedRole = this.client_uuid;
          this.selectedClient(this.client_uuid);
          this.direction = 'setting_direction';
          this.$emit('setDirection', 'setting_direction');
        })
      }
    },
    methods: {
      ...mapActions({
        getListDocs: 'clicarSettings/getListDocs',
        sortByCustomer: 'clicarSettings/sortByCustomer',
        setTerms: 'clicarSettings/setTerms',
        savePersonalTermsByClient: 'clicarSettings/savePersonalTermsByClient'
      }),
      ...mapMutations({
        SET_TABS: 'clicarSettings/SET_TABS',
        WRITE_LIST_CUSTOMERS: 'clicarSettings/WRITE_LIST_CUSTOMERS',
        CHANGE_SELECTED_CUSTOMER: 'clicarSettings/CHANGE_SELECTED_CUSTOMER',
      }),
      changeTerms(terms) {
        if (this.tab === 'FOR_CLIENT' && this.client_uuid !== '') {
          this.savePersonalTermsByClient(terms)
            .then(() => {
              if (this.answerByServer === 'success') {
                this.$notification({
                  type: 'system_notification_success',
                  message: 'Персональный срок по документу сохранен у клиента'
                });
              } else if (this.answerByServer === 'error') {
                this.$notification({
                  type: 'system_notification_error',
                  message: 'Не удается сохранить персональные сроки для клиента'
                })
              }
            })
        } else {
          this.setTerms(terms)
            .then(() => {
              if (this.answerByServer === 'success') {
                this.$notification({
                  type: 'system_notification_success',
                  message: 'Сроки для документов сохранены'
                });
              } else if (this.answerByServer === 'error') {
                this.$notification({
                  type: 'system_notification_error',
                  message: 'Не удается сохранить для документов'
                })
              }
            })
        }
      },
      selectedClient(uuid) {
        if (uuid) {
          this.sortByCustomer(uuid);
        } else {
          this.getListDocs(this.clicar_uuid);
        }
      },
      async loadListCustomers({page, size}) {
        try {
          const {data} = await api.clicar_setting.getListCustomers({page, size}, this.clicar_uuid);
          let html = `<div class="ob-selector_gear" title="Настроено индивидуально"><i class="icon settings"/></div>`;
          data.content = data.content.map(key => {
            if (key.isCustomized) {
              return {
                ...key,
                html
              }
            }
            return key
          });
          this.WRITE_LIST_CUSTOMERS(data.content);
          return data;
        } catch (e) {
          console.error('Ошибка загрущки списка клиентов:', e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных"
          });
          this.WRITE_LIST_CUSTOMERS([]);
          return [];
        }
      }
    }
  }
</script>